#programme créé par Tristan Pagezy en octobre 2020
#Bataille navale
#quand x et y sont demandés c'est toujours le coté en haut à gauche du quadrillage ou du carré
import tkinter as tk
import turtle
import random as r

def go(x, y): #déplace la tortue sans écrire
    t.up()
    t.goto(x, y)
    t.down()
def colone(x, y, nbCote): #crée une colone que carrés
    go(x, y)
    for loop in range(nbCote):
        t.forward(30)
        t.right(90)
    if nbCote == 3:
        t.right(90)
    y = y - 30
    return y
def quadrillage(departx, departy):   #crée un quadrillage de carres
    go(departx, departy)
    x = departx
    y = departy
    for nombre in range(1, 21):
        y = colone(x, y, 4)
        go((x-2), (y+10))
        t.write(nombre, move=False, align="right", font=("Arial", 8, "normal"))
    y = departy
    x = x + 30
    go((x-10), (y+2))
    t.write("1", move=False, align="right", font=("Arial", 8, "normal"))
    for nb in range(2, 21):
        for loop in range(20):
            y = colone(x, y, 3)
        y = departy
        x = x + 30
        go((x-10), (y+2))
        t.write(nb, move=False, align="right", font=("Arial", 8, "normal"))

def coordsSouris(event): #met les posotion d'un clic dans les variables X et Y
    global X
    X = event.x
    global Y
    Y = event.y
    global i
    i = False
def coorEnNb(coor0, coordonees): #transforme les coordonees d'un clic en position dans le quadrillage
    X0 = coor0
    t = 1
    for case in range(20):
        if (coordonees >= X0) and (coordonees <= (X0+30)):
            return t
        X0 = X0+30
        t = t+1
    t = -1
    return t
def nbEnCoor(coor0, nb): #transforme les position dans un quadrillage en coordonees de clic ou pour Turtle
    #coor0 est le point en haut à gauche du quadrillage
    for case in range(nb-1):
        coor0 = coor0 + 30
    return coor0
def nbEnCoorNeg(coor0, nb):#transforme les position dans un quadrillage en coordonees pour y pour Turtle
    for case in range(nb-1):
        coor0 = coor0 - 30
    return coor0
def bateau(x, y): #crée un bateau
    go((x+2), (y-22))
    t.forward(25)
    t.left(90)
    t.forward(10)
    t.left(90)
    t.forward(5)
    t.right(90)
    t.forward(5)
    t.left(90)
    t.forward(15)
    t.left(90)
    t.forward(5)
    t.right(90)
    t.forward(5)
    t.left(90)
    t.forward(10)
    t.left(90)
def croix(x, y): #crée une croix
    go(x, y)
    t.right(45)
    t.forward(42)
    go((x+30),y)
    t.right(90)
    t.forward(42)
    t.left(135)

dificulté = int(input("Quel dificulté ?(entre 1 et 20(1=facile, 20=sans aide)) "))
print("Si la croix est rouge, c'est que vous êtes dans le bon axe")
print("Grille en cours de préparation, veulliez patienter...")

#initialisation de tkinter et de Turtle
window = tk.Tk()
canvas = tk.Canvas(master=window, width=1400, height=702)
canvas.grid(padx=2, pady=2, row=0, column=0, rowspan=10, columnspan=10)
t = turtle.RawTurtle(canvas)

t.speed(1000)
# création du quadrillage
quadrillage(-600, 250)
t.color("red")
quadrillage(50, 250)   #la création du quadrillage prend un peu moins de 2 minutes
t.color("black")
go(-300, 270)
t.write("Défense", move=False, align="center", font=("Liberation Serif", 12, "normal"))
go(350, 270)
t.write("Attaque", move=False, align="center", font=("Liberation Serif", 12, "normal"))
go(0, 290)
t.write("BATAILLE NAVALE", move=False, align="center", font=("Comic Sans MS", 30, "normal"))
print("La fenêtre est prête, vous pouvez ouvir l'onglet")

t.speed(10)
# placement des bateaux
batX = [0]*3
batY = [0]*3
X = 0
Y = 0
for bateaux in range(3):
    plac = True
    while plac:
        i = True
        print("Placer un bateau en zone de défense")
        while i: #attend le clic gauche de la souris pour continuer le programme
            canvas.bind("<Button-1>", coordsSouris)
            window.update_idletasks()
            window.update()
        batX[bateaux] = coorEnNb(102, X)
        batY[bateaux] = coorEnNb(102, Y)
        #print(batX[bateaux], batY[bateaux])
        if ((batX[bateaux] == -1) or (batY[bateaux] == -1) or \
        ((batX[bateaux-1] == batX[bateaux]) and (batY[bateaux-1] == batY[bateaux])) or \
        ((batX[bateaux-2] == batX[bateaux]) and (batY[bateaux-2] == batY[bateaux]))):
            print("Mauvais placement ! Veuillez recommencer !")
        else:
            plac = False
    desBatX = nbEnCoor(-600, batX[bateaux])
    desBatY = nbEnCoorNeg(250, batY[bateaux])
    bateau(desBatX, desBatY)

#placement des bateaux de l'adversaire
batOrdiX = [0]*3
batOrdiY = [0]*3
for bateauxOrdi in range(3):
    plac = True
    while plac:
        batOrdiX[bateauxOrdi] = r.randint(1, 20)
        batOrdiY[bateauxOrdi] = r.randint(1, 20)
        if (((batOrdiX[bateauxOrdi-1] == batOrdiX[bateauxOrdi]) and (batOrdiY[bateauxOrdi-1] == batOrdiY[bateauxOrdi])) or \
        ((batOrdiX[bateauxOrdi-2] == batOrdiX[bateauxOrdi]) and (batOrdiY[bateauxOrdi-2] == batOrdiY[bateauxOrdi]))):
            print()
        else:
            plac = False
    #print(batOrdiX[bateauxOrdi], batOrdiY[bateauxOrdi]) # afficher les bateaux ennemis


memattaque = [0]*400
memattaqueOrdi = [0]*400
bateauCoulesJoueur=0
bateauCoulesOrdi = 0
boucle = 0
while (bateauCoulesJoueur!=3) and (bateauCoulesOrdi!=3):
    #attaque du Joueur
    att = True
    while att:
        dejapose = False
        i = True
        print("Attaquez dans la zone attaque !")
        while i:
            canvas.bind("<Button-1>", coordsSouris)
            window.update_idletasks()
            window.update()
        attaqueX = coorEnNb(752,X)
        attaqueY = coorEnNb(102,Y)
        posattaque = (attaqueY*100) + attaqueX
        #vérification si le tir n'as pas déjà été effectué précédement
        for position in range(400):
            if memattaque[position] == posattaque:
                dejapose = True
        if (attaqueX == -1 or attaqueY == -1 or dejapose == True):
            print("Attaque hors du champs d'action. Réessayer !")
        else:
            att = False
            memattaque[boucle] = posattaque
            #en fonction de la dificulté, si on a de la chance, affiche la croix en rouge si on est dans le bonne axe
            if dificulté<20:
                hazard = r.randint(1,dificulté)
                if hazard == 1:
                    if (attaqueX == batOrdiX[0] or attaqueY == batOrdiY[0]) or \
                    (attaqueX == batOrdiX[1] or attaqueY == batOrdiY[1]) or \
                    (attaqueX == batOrdiX[2] or attaqueY == batOrdiY[2]):
                        t.color("red")
            croix(nbEnCoor(50, attaqueX), nbEnCoorNeg(250, attaqueY))
            if (attaqueX == batOrdiX[0] and attaqueY == batOrdiY[0]) or \
            (attaqueX == batOrdiX[1] and attaqueY == batOrdiY[1]) or \
            (attaqueX == batOrdiX[2] and attaqueY == batOrdiY[2]):
                print("Touché !")
                bateau(nbEnCoor(50, attaqueX), nbEnCoorNeg(250, attaqueY))
                bateauCoulesOrdi = bateauCoulesOrdi+1
            else :
                print("Raté")
            t.color("black")
    #attaque de l'ordinateur
    attOrdi = True
    while attOrdi:
        dejaposeOrdi = False
        attaqueOrdiX = r.randint(1,20)
        attaqueOrdiY = r.randint(1,20)
        posattaqueOrdi = (attaqueOrdiY*100) + attaqueOrdiX
        #vérification si le tir n'as pas déjà été effectué précédement
        for position in range(400):
            if memattaqueOrdi[position] == posattaqueOrdi:
                dejaposeOrdi = True
        if dejaposeOrdi == False:
            attOrdi = False
            memattaqueOrdi[boucle] = posattaqueOrdi
            boucle  = boucle +1
            croix(nbEnCoor(-600, attaqueOrdiX), nbEnCoorNeg(250, attaqueOrdiY))
            #si on touche
            if (attaqueOrdiX == batX[0] and attaqueOrdiY == batY[0]) or \
            (attaqueOrdiX == batX[1] and attaqueOrdiY == batY[1]) or \
            (attaqueOrdiX == batX[2] and attaqueOrdiY == batY[2]):
                print("Aïe")
                bateauCoulesJoueur = bateauCoulesJoueur+1
            else :
                print("Ouf !")
#Dire si victoire ou défaite (ou égalité dans de très rare cas)
go(0,0)
if bateauCoulesJoueur == bateauCoulesOrdi:
    t.write("Egalité !", move=False, align="center", font=("Comic Sans MS", 100, "normal"))
elif bateauCoulesJoueur == 3:
    t.color("red")
    t.write("Défaite", move=False, align="center", font=("Comic Sans MS", 100, "normal"))
    print("Défaite")
    for bat in range(3):
        bateau(nbEnCoor(50,batOrdiX[bat]), nbEnCoorNeg(250,batOrdiY[bat]))
elif bateauCoulesOrdi == 3:
    t.color("green")
    t.write("Victoire !!!", move=False, align="center", font=("Comic Sans MS", 100, "normal"))
    print("Victoire !!!")

#fin